Feature: Player

  As a game player I want to have a player on database

  Scenario: Create new player
    Given config key 'initial_player.wallet.gold' is '10'
    And   config key 'initial_player.name' is 'Guest'
    When  client call route 'rubypitaya.playerHandler.authenticate'
    Then  server should response 'code' as 'RP-200'
    And   server should response 'data.name' as 'Guest'
    And   server should response 'data.gold' as '10'

  Scenario: Get player info
    Given the following player:
      | name    | gold | user_id                              |
      | Someone | 15   | 00000000-0000-0000-0000-000000000001 |
    And   the player 'Someone' is authenticated
    When  client call route 'rubypitaya.playerHandler.getInfo'
    Then  server should response the following json:
      """
      {
        "code": "RP-200",
        "data": {
          "name": "Someone",
          "gold": 15,
          "userId": "00000000-0000-0000-0000-000000000001"
        }
      }
      """
