require 'active_record'
require 'rubypitaya/core/database_config'

module RubyPitaya

  class DatabaseConnector

    def initialize(database_config)
      @database_config = database_config
    end

    def connect
      ActiveRecord::Base.establish_connection(@database_config.connection_data)
      ActiveRecord::Base.logger = ActiveSupport::Logger.new(STDOUT)
      ActiveSupport::LogSubscriber.colorize_logging = true
    end

    def disconnect
      ActiveRecord::Base.connection.close
    end
  end
end