require 'rspec'

ENV['RUBYPITAYA_ENV'] = 'test'

require 'rubypitaya/core/helpers/setup_helper'
require 'rubypitaya/core/spec-helpers/handler_spec_helper'

RSpec.configure do |config|
  config.include RubyPitaya::HandlerSpecHelper

  config.before(:each) do
    ActiveRecord::Base.descendants.each { |c| c.delete_all unless c == ActiveRecord::SchemaMigration }
  end

  config.after(:each) do
    ActiveRecord::Base.clear_active_connections!
  end
end